package com.ruoyi.web.controller.dragForm;

import com.ruoyi.common.annotation.Anonymous;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.system.entity.CommonEntity;
import com.ruoyi.system.service.ICommonService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

@Anonymous
@RestController
@RequestMapping("/dragform/common")
public class CommonController extends BaseController {

    @Resource
    private ICommonService commonService;

    /**
     * 查询
     */
    @GetMapping("/selectList")
    public TableDataInfo selectList( CommonEntity commonEntity) {
        startPage();
        return getDataTable(commonService.selectList(commonEntity.getFormMap()));
    }

    /**
     * 批量新增
     */
    @PostMapping("/batchInsert")
    public AjaxResult batchInsert(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.batchInsert(map));
    }

    /**
     * 修改
     */
    @PutMapping("/edit")
    public AjaxResult edit(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.edit(map));
    }

    /**
     * 批量删除
     */
    @DeleteMapping("/batchDelete")
    public AjaxResult batchDelete(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.batchDelete(map));
    }

    @GetMapping("/getTableList")
    public AjaxResult queryTableList(String sqlkey) {

        return AjaxResult.success();
    }

}
